﻿<?xml version="1.0" encoding="utf-8"?>
<nlog xmlns="http://www.nlog-project.org/schemas/NLog.xsd"
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      autoReload="true"
      throwExceptions="true">
    <targets>
        <!-- Не более 100 файлов размером не более 1М, итого максимум 100М на журналы -->
        <target name="logfile"
                xsi:type="File"
                fileName="log/${shortdate}.txt"
                encoding="utf-8"
                layout="${longdate} ; ${pad:padding=5:fixedlength=true:inner=${uppercase:${level}}} ; ${logger:shortName=true} ; ${message} ; ${exception:format=message,stacktrace:maxInnerExceptionLevel=5}"
                concurrentWrites="true"
                keepFileOpen="false"
                maxArchiveFiles="100"
                archiveAboveSize="1000000"
                archiveEvery="Day"
            />
        <target name="console" xsi:type="ColoredConsole" useDefaultRowHighlightingRules="false"
                layout="${longdate} ; ${pad:padding=5:fixedlength=true:inner=${uppercase:${level}}} ; ${logger:shortName=true} ; ${message} ; ${exception:format=message,stacktrace:maxInnerExceptionLevel=5}">
            <highlight-row condition="level == LogLevel.Trace" foregroundColor="Gray" />
            <highlight-row condition="level == LogLevel.Debug" foregroundColor="DarkGreen" />
            <highlight-row condition="level == LogLevel.Info" foregroundColor="White" />
            <highlight-row condition="level == LogLevel.Warn" foregroundColor="Yellow" />
            <highlight-row condition="level == LogLevel.Error" foregroundColor="Red" />
            <highlight-row condition="level == LogLevel.Fatal" foregroundColor="Red" backgroundColor="White" />
        </target>
    </targets>
    <rules>
        <!-- протоколирование для всех и пусть никто не уйдёт незапротоколированным -->
        <logger name="*" minlevel="Trace" writeTo="logfile, console" />
    </rules>
</nlog>
